Index: branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views-3.3.csproj
===================================================================
--- branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views-3.3.csproj	(revision 8648)
+++ branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views-3.3.csproj	(revision 8655)
@@ -121,4 +121,10 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
+    <Compile Include="ValueConfigurationViews\CheckedValueConfigurationListView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ValueConfigurationViews\CheckedValueConfigurationListView.Designer.cs">
+      <DependentUpon>CheckedValueConfigurationListView.cs</DependentUpon>
+    </Compile>
     <Compile Include="ValueConfigurationViews\RangeView.cs">
       <SubType>UserControl</SubType>
Index: branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.Designer.cs
===================================================================
--- branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.Designer.cs	(revision 8648)
+++ branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.Designer.cs	(revision 8655)
@@ -79,5 +79,5 @@
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.optimizeCheckBox);
       this.Controls.Add(this.viewHost);
Index: branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.cs
===================================================================
--- branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.cs	(revision 8648)
+++ branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding.Views/3.3/OptimizableView.cs	(revision 8655)
@@ -70,4 +70,5 @@
             } else {
               viewHost.Content = pc.ValueConfigurations;
+              viewHost.ViewType = typeof(CheckedValueConfigurationListView);
             }
           } else if (vc != null) {
Index: branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding/3.3/ValueConfigurations/CheckedValueConfigurationCollection.cs
===================================================================
--- branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding/3.3/ValueConfigurations/CheckedValueConfigurationCollection.cs	(revision 8648)
+++ branches/ParameterConfigurationEncoding/HeuristicLab.Encodings.ParameterConfigurationEncoding/3.3/ValueConfigurations/CheckedValueConfigurationCollection.cs	(revision 8655)
@@ -28,5 +28,4 @@
 
 namespace HeuristicLab.Encodings.ParameterConfigurationEncoding {
-  // TODO: check that at least 1 element needs to be selected
   // TODO: control creatable item types ### EDIT: done?
   [StorableClass]
@@ -81,9 +80,7 @@
     private void RegisterEvents() {
       this.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IValueConfiguration>>(CheckedValueConfigurationList_ItemsAdded);
-      this.CheckedItemsChanged += new CollectionItemsChangedEventHandler<IndexedItem<IValueConfiguration>>(CheckedValueConfigurationList_CheckedItemsChanged);
     }
 
     private void DeregisterEvents() {
-      this.CheckedItemsChanged -= new CollectionItemsChangedEventHandler<IndexedItem<IValueConfiguration>>(CheckedValueConfigurationList_CheckedItemsChanged);
       this.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<IValueConfiguration>>(CheckedValueConfigurationList_ItemsAdded);
     }
@@ -99,10 +96,5 @@
       }
     }
-    private void CheckedValueConfigurationList_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<IValueConfiguration>> e) {
-      // TODO: view does not get notified
-      if (!this.CheckedItems.Any()) this.SetItemCheckedState(e.Items.Single().Value, true);
-    }
     #endregion
-
   }
 }